/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.jobs.personjob.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.springblade.community.agency.entity.Agency;
import org.springblade.community.agency.service.IAgencyService;
import org.springblade.community.residential.entity.Residential;
import org.springblade.community.residential.service.IResidentialService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.jobs.personjob.entity.PersonJob;
import org.springblade.jobs.personjob.service.IPersonJobService;
import org.springblade.jobs.personjob.vo.PersonJobVO;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.Map;

/**
 * 人员工单 控制器
 *
 * @author BladeX
 * @since 2020-10-17
 */
@RestController
@AllArgsConstructor
@RequestMapping("jobs/personjob")
@Api(value = "人员工单", tags = "人员工单接口")
public class PersonJobController extends BladeController {

	private IPersonJobService personJobService;
	private IAgencyService agencyService;
	private IResidentialService residentialService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入personJob")
	public R<PersonJob> detail(PersonJob personJob) {
		PersonJob detail = personJobService.getOne(Condition.getQueryWrapper(personJob));
		return R.data(detail);
	}

	/**
	 * 分页 人员工单
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入personJob")
	public R<IPage<PersonJob>> list(@RequestParam Map<String,Object> personJob, Query query) {
		Object agencyId = personJob.get("agencyId");
		if (agencyId != null){
			Agency agency = this.agencyService.getById(Long.parseLong(agencyId.toString()));
			personJob.put("orgPosition", agency.getOrgPosition());
			personJob.remove("agencyId");
		}
		Object residentialId = personJob.get("residentialId");
		if (residentialId != null){
			Residential residential = this.residentialService.getById(Long.parseLong(residentialId.toString()));
			personJob.put("orgPosition", residential.getOrgPosition());
			personJob.remove("residentialId");
		}
		IPage<PersonJob> pages = personJobService.page(Condition.getPage(query), Condition.getQueryWrapper(personJob,PersonJob.class));
		return R.data(pages);
	}

	/**
	 * 自定义分页 人员工单
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入personJob")
	public R<IPage<PersonJobVO>> page(PersonJobVO personJob, Query query) {
		IPage<PersonJobVO> pages = personJobService.selectPersonJobPage(Condition.getPage(query), personJob);
		return R.data(pages);
	}

	/**
	 * 新增 人员工单
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入personJob")
	public R save(@Valid @RequestBody PersonJob personJob) {
		return R.status(personJobService.save(personJob));
	}

	/**
	 * 修改 人员工单
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入personJob")
	public R update(@Valid @RequestBody PersonJob personJob) {
		return R.status(personJobService.updateById(personJob));
	}

	/**
	 * 新增或修改 人员工单
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入personJob")
	public R submit(@Valid @RequestBody PersonJob personJob) {
		return R.status(personJobService.saveOrUpdate(personJob));
	}


	/**
	 * 删除 人员工单
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(personJobService.deleteLogic(Func.toLongList(ids)));
	}


}
